//package graph;
import java.util.*;
import java.io.*;//File;

public class graph {
    static int N, M;
    static int[][][] arG;
    static PriorityQueue<m_road> q_E = new PriorityQueue<m_road>();
    static PriorityQueue<m_road> q   = new PriorityQueue<m_road>();
    static int[] prev;  
        

    public static void main(String[] args) {
        long d = System.currentTimeMillis();
        
        //Read the graph.in and fill the variables  
        ReadTheFile();
        
        m_road m;
        int i=0;
        while (! q_E.isEmpty()){
            m=q_E.poll();            
            //Find the Min Path  
            PathFromAtoB(m.getX(),m.getY());
            if ((System.currentTimeMillis()-d)>1650) {break;}         
        }
        
        for (i = 0; i < N; i++) {
			for (int j = i+1; j < N; j++) {
				if(arG[i][j][2]>0){
					q.add(new m_road("" + arG[i][j][2], i, j, arG[i][j][0], arG[i][j][1]));
				}
			}
		}
        
        prev = new int[M];
        Krusk();
        
        //System.out.println(" Za wreme " +  (double)(System.currentTimeMillis()-d));
    }
    private static void PathFromAtoB(int A, int B){
        //point A is the A row of array arG
        //point B is the B row of array arG
        //To get all paths from A to B mean: 
        // if A to x have a path then put it in the priority queue
        // mark it as visited
        
        int[][] visit=new int[N][N];
        //System.out.println("Find Min Path from " + (A+1) + " to " + (B+1) );        
        PriorityQueue<m_road> qD = new PriorityQueue<m_road>();
        
        for (int x = 0; x < N; x++) {
            if (arG[A][x][2]!=0){
                //System.out.println("    Add mag - " + arG[A][x][2] + " km " + arG[A][x][0] +
                //                    " A " + (A+1) + " x " + (x+1) );
                qD.add(new m_road(A + " " + x, A, x, arG[A][x][0],arG[A][x][1]));
            }
        }
        m_road tmpM;
        int a1,b1,h;
        while (!qD.isEmpty()){
            tmpM=qD.poll(); //get the mines path  form A
            a1=tmpM.y;
            b1=tmpM.x;
            h  = tmpM.getD();
            visit[a1][b1]=1;
            visit[b1][a1]=1;

            //System.out.println( "       Poll " + a1 + " " + b1 + "  mag " + arG[b1][a1][2]);             
            
            if (a1 == B)    {
              //  System.out.println ("           dist " + h + "\n" + tmpM ); 
                ChangeTheDriversCo(tmpM.toString(), arG[A][B][1] );
                break;
            }
            for (int x = 0; x < N; x++){
                if(visit[a1][x]==0){
	            	if (arG[a1][x][2]!=0){ 
	                    if ((x!=a1)||(x!=A)){  
	                        qD.add(new m_road(tmpM + " " + a1 + " " + x, a1, x, h+arG[a1][x][0], arG[a1][x][1] ));
	                        //System.out.println( "           ADD " + x + " " + x );
	                    }
	                }
                }
            }   
        }        
    }   
    private static void ChangeTheDriversCo(String s, int CoDr) {
    	String[] aS;
    	aS = s.split("[ ]");
    	for (int i = 0; i < aS.length-1; i++) {
			int a,b;
			a=Integer.parseInt(aS[i]);
			b=Integer.parseInt(aS[++i]);
			if (arG[a][b][1]>CoDr) {
				arG[a][b][1]=CoDr;
				arG[b][a][1]=CoDr;
			}
		}
    	
	}
           
    private static void Krusk() {
        int v1, v2;
        m_road m;
        String s="";
        if (N==(M-1)){
            for (int i = 1; i <= M; i++) {
                s= s + " " + i + "\n";
            }
        }else{ 
        while (! q.isEmpty()){
            m=q.poll();
            //            
            v1=GetRoot(m.getX());
            v2=GetRoot(m.getY());
            if (v1!=v2){
                s=s + m + "\n";
                prev[v1]=v2;
                
            }
        }
        }
        WriteTheFile(s);
    }
    
    private static int GetRoot(int v) {
        int root, vv, svv;
        root=v;
        while (prev[root]!=0){
            root=prev[root];
        }
        vv=v;
        while (vv!=root) {
            svv=vv; 
            vv=prev[vv];
            prev[svv]=root;
        }
        return root;
    }
    private static void WriteTheFile(String s){
        FileWriter fw = null;
        try {
            fw = new FileWriter("graph.out");
            fw.write(s);
            fw.close();
        }
        catch (Exception e) {
            e.getMessage();
            System.err.println("Unexpected exception");
            e.printStackTrace();
        }
    }
    private static void ReadTheFile() {
        
        String line; 
        //Open graph.in and read the N, M,P and the matrix 
        FileReader cFile = null; 
        BufferedReader cReader = null;
        
        try {
            cFile = new FileReader("graph.in");
            cReader = new BufferedReader(cFile);
            String[] aS;
            //Read N,M
            line = cReader.readLine();
            aS = line.split("[ ]");
            N =  Integer.parseInt(aS[0]);//N
            M =  Integer.parseInt(aS[1]);//M
            arG = new int[N][N][3];            
            
            //Read the HighWays
            int x, y , z ;
            //m_road mm;
            for (int i = 0; i < M ; i++) {
                line = cReader.readLine();
                aS = line.split("[ ]");                
                x =  Integer.parseInt(aS[0])-1;
                y =  Integer.parseInt(aS[1])-1;
                z =  Integer.parseInt(aS[2]);//length of road
                arG[x][y][0]=z; 
                arG[y][x][0]=z; 
                arG[y][x][2]=i+1;  
                arG[x][y][2]=i+1;
                   
                
            }
            for (int i = 0; i < N ; i++) {
                line = cReader.readLine();
                aS = line.split("[ ]");   
                for (int j = 0; j < i; j++ ){                              
                    arG[i][j][1]=Integer.parseInt(aS[j]);
                    if (arG[i][j][1]>0) {
                        //because we need a max count of drivers
                        //but the queue prior it by min value 
                        arG[i][j][1]=1000000000-arG[i][j][1];
                        arG[j][i][1] = arG[i][j][1];                    
                        q_E.add(new m_road(""+(i+1), i, j, arG[i][j][1]-1000000000,0));
                    }                     
                }
            } 
        }

        catch (Exception e) {
            e.getMessage();
            System.err.println("Unexpected exception");
            e.printStackTrace();
        }
        finally {
            //if (cFile!=null) cFile.close();
        }

    }
    private static void printArr(double ar[][]){
        for (int i=0;i<N;i++){
            for (int j=0;j<N;j++){
                System.out.print( ar[i][j] + " ");
            }            
            System.out.print("\n");
        } 
        System.out.print("\n"); 
    }

    static class m_road implements Comparable<m_road> {
        //Highway - number, town x town y, distance
        private int  x, y;
        private String a;
        int dist, driv;
        
        public m_road(String iA, int iX, int iY, int iD, int iDr){
            this.a=iA; this.x=iX;
            this.y=iY; this.dist=iD; this.driv=iDr;
        }
        public int getX(){
            return x;
        }
        public int getY(){
            return y;
        }
         public int getD(){
            return dist;
        } 
        //@Override
        public int compareTo(m_road m){
            if (this.dist==m.dist) {
            	if (this.driv==m.driv) return 0;
            	return (this.driv>m.driv)?1:-1;
            }
            return (this.dist>m.dist)?1:-1;
        }

        @Override
        public String toString(){
            return "" + this.a;
            //return "road " + this.a + " dist " + this.dist;
            
        }
    }
}
     
